********************************************************************************
* CD-Player 1. Versuch                                                         *
* begonnen :00.00.2028                                                         *
* letzte nderung :                                                            *
********************************************************************************
;**************************************************************************
; (C)1993 ATARI CORP.       SECRET & CONFIDENTIAL       ALL RIGHTS RESERVED
;
;
;                                CD_audio.s
;
;       This MC68K program demonstrates the use of some of the subroutines 
;       presently available to drive the Jaguar CD Module in standard CD
;       audio playback mode.  All calls to the CD Module are made as "bsrs".
;
;       This program requires assembly and linking of the DSP program 
;       'Echo.gas'.
;
;       The makefile is named 'CD-audio.mak'.
;
;       The hardware assumptions here are a CDROM interface card Rev 2.0
;       mounted in the 2 MB Sylvester Development System.
;
;
;                                REVISION HISTORY
;
; REV.  DATE       BY            DESCRIPTION OF EDIT
; """"  """"       ""            """""""""""""""""""
; 1.00  01 Oct 93  DMS   Based on CD.107
; 2.00  12 Nov 93  DMS   Update to use for testing Jag CDROM V1.00 PCB
; 3.01  24 Feb 94  TD    Removed all references to memcon
;****************************************************************************
DEBUG             EQU 1

                mc68000
                OPT C+,T+,S-,P+,B+,Z+,Q+,X+,K+
                opt d+

                PATH 'E:\NEWSRC\'
                INCLUDE "68k_mac\help.mac"
                INCLUDE "68k_inc\jaguar.inc"

                include "cd_audio\cd_inits.inc" ; CD-related equates
;>                INCLUDE "68k_inc\cd.inc"

                 include "cd_audio\cdplay.equ"
;--------------
;- Variablen --
                RSRESET
                RS.o ob_list,10
                RS.o ob_list0,10
                RS.w count_obj
                RS.w width
                RS.w height
                RS.w a_hde
                RS.w a_hdb
                RS.w a_vdb
                RS.w a_vde
                RS.w PauseFlag
                RS.w CurrTrack
                RS.l Cursor
                RS.w KeyPtrIn
                RS.w KeyPtrOut
                RS.l KeyBuffer,8
                RS.l KeyLast
                RS.l KeyLastRep
                RS.l KeyCurrent
                RS.l KeyMask
                RS.w KeyCounter
                RS.w CD_stopped

                RS.l StackBottom,30
                RS.l stack
;--------------
vars_len       equ RSCOUNT
vars           EQU $000F000

max_y_txt      EQU 10*8
max_x_txt      EQU 48*8
TextScreen     EQU $30000

GfxScreen      EQU $100000
max_x_gfx       equ 320
max_y_gfx       equ 100



;>DSP_stop  equ   $F1C310         ; Stop-DSP semaphore from M68K

*INIT
* created 24.09.95
* (c) Bastian Schick
*
* setup OP,GPU,DSP,CPU to a defined state
* OP = STOP (at $0)
* DSP,GPU : big-endian,stopped,IRQs disabled
* dummy irq
* inits SP to $1000
* stops PIT and JPIT1 & 2
* 68k-SR set to $2000
* CPU-IRQs disabled
* CPU registers are cleared (for debug purposes)
;-----------------
;--    INIT     --
INIT:             move    #$2700,sr
                  lea     $1000.w,sp
                  lea     $F00000,a0
                  move.l  #$070007,d0           ; big endian
                  move.l  d0,$210C(a0)
                  move.l  d0,$F1A10C
                  moveq #0,d0
                  move.l d0,$2114(a0)           ; stop gpu
                  move.l d0,$f1a114             ; stop dsp
                  move.l d0,$2100(a0)           ; disable GPU-IRQs
                                                ; disable DSP-IRQs
                  move.l #%10001111100000000,$f1a100
                  move.l #%111111<<8,$f10020    ; clear and disable IRQs

                  move.l  d0,0.w
                  moveq   #4,d0
                  move.l  d0,4.w
                  moveq   #0,d0
                  move.l  d0,$20(a0)            ; set OP to STOP-OBJECT
                  move.w  d0,$26(a0)            ; clear OP-Flag
                  move.l  d0,$2A(a0)            ; border black
                  move.w  d0,$56(a0)            ; set CRY mode to color/not BW
                  move.w  d0,$58(a0)            ; background black
                  move.l  d0,$50(a0)            ; stop PIT
                  move.l  d0,$f10000            ; stop JPIT1
                  move.l  d0,$f10004            ; stop JPIT2
                  move.l  #$1F00<<16,$E0(a0)    ; clear pending irqs
                  move.w  #$7fff,$4e(a0)        ; no VI
                  lea     dummy_irq(pc),a0
                  move.l  a0,$0100.w
                  bra.s   INIT1
dummy_irq:        move.l #$1f00<<16,$f000e0
                  rte
INIT1:            moveq #0,d0
                  moveq #0,d1
                  moveq #0,d2
                  moveq #0,d3
                  moveq #0,d4
                  moveq #0,d5
                  moveq #0,d6
                  moveq #0,d7
                  move.l d0,a0
                  move.l d0,a1
                  move.l d0,a2
                  move.l d0,a3
                  move.l d0,a4
                  move.l d0,a5
                  move.l d0,a6
                  move.l a0,usp

;-----------------
                move.w #$1865,$f00000
                move.l #0,BUTCH
                move.w  #$100,$f14000    ; unmute
 
*****************
* Clear Memory  *
Clearmem:
                move.l  #CD_TOC,a0      ; our lowest DRAM address, see 'CD_inits.inc'
                move.l  #$30000,a1      ; our highest DRAM address
Clermem1:       clr.l (a0)+     ; clear CD variables and data buffer area
                cmp.l   a0,a1
                bne     Clermem1
*****************
                lea vars,a6                     ; set var-base
                lea stack(a6),sp                ; init SP
                lea (a6),a0
                move.w  #vars_len>>2,d0
clear_var:      clr.l   (a0)+
                dbra    d0,clear_var            ; clear vars

                bsr VideoInit                   ; init video-timing
                bsr InitOP                      ; init op-list and VI

                move.w #26590,$f00050
                move.w #19,$f00052               ; 50Hz
                move.l #$ff0fdfff,KeyMask(a6)
                clr.l KeyMask(a6)

                moveq #0,d0                     ; color-index = 0
                move.l #$883080FF,d1            ; BG = grey ; FG = Pink
                bsr InitTxtScreen

                move.l #$12340000,a0
                move a0,usp                     ; use USP as control for VI

                move.w #$4c1,$f00028            ; CRY-mode (non-overscanned)
                move.w #$f0ff,$f00058           ; border red

                bsr StartCD
                move.l #$4000,Volume
                move.l #$80,Panning

                moveq #0,d7
loop            clr.l Cursor(a6)
                moveq #0,d0
                move.b CD_track+3,d0
                bsr PrintDEZ2
                moveq #"|",d0
                bsr PrintChar
                bsr Get_time
                moveq #0,d0
                move.b CD_Amins+3,d0
                bsr PrintDEZ2
                moveq #":",d0
                bsr PrintChar
                moveq #0,d0
                move.b CD_Asecs+3,d0
                bsr PrintDEZ2
                move.l #1,Cursor(a6)
                move.l Volume,d0
                move.l $f1b000,d0
                bsr PrintHEXl
 
                move.l Panning,d0
                move.l $f1b004,d0
                bsr PrintHEXl
                bsr GetKey
                beq.s loop
                cmp.l #$10001,d0
                beq.s reset
                bsr DoKey
                bra.s loop
****************
* reset        *
reset:          tst.w CD_stopped(a6)
                bne.s reset1
                bsr Stop_CD
reset1:
                move.l #1,DSP_stop
reset2          move.l $f1a114,d0
                lsr.w #1,d0
                bcs.s reset2
                moveq   #0,d0
                move.l  d0,$00F02114
                move.l  d0,$00F1A114
                move.l  d0,$00F10000
                move.l  #$FF00FF00,$00F00020
                move.l  d0,$00F1A154
                move.l  d0,$00F1A150
                move.l  d0,$00F00050
                move.l  d0,$00F03FF4

                move.w  #$1861,$00F00000
                move.l  $00E00004,-(sp)
                rts
****************
                LOCAL
StartCD::       bsr InitDSP     ; load'n' start DSP
                move.l #$14,$f1a154
                move.w #1,d0
                bsr CDmode_4
                move.w #$100,JOYSTICK
 
; DSP's running.  Now start disc
                moveq #0,d1
                bsr Spin_CD
                moveq #-1,d0
.l0             dbra d0,.l0

                moveq #0,d4
                bsr CDminmax
                moveq #0,d4
                bsr CDbigTOC
                bsr Stop_CD
                bsr PrintTOC
                moveq #-1,d0
.l1             dbra d0,.l1
                moveq.l #1,d1   ; start from 1st track
                bsr Play_CD
                rts

                LOCAL
PrintTOC::      move.l #2,Cursor(a6)
                lea CD_TOC,a0
.l0             cmp.l #$E0F,(a0)
                beq.s .l9
                moveq #4,d7
.l1                 move.l (a0)+,d0
                    bsr PrintHEXl
                  dbra d7,.l1
                clr.w Cursor(a6)
                addq.w #1,Cursor+2(a6)
                bra.s .l0
.l9             rts
****************
* DoKey        *
DoKey::         btst #28,d0
                beq.s DoKey1
                bsr GetKey
                btst #28,d0
                bne Stop
                not.w PauseFlag(a6)
                beq Pause_CD
                bra Unpause_CD

DoKey1          btst #23,d0
                beq.s DoKey2
                addq.w #1,CD_track+2
                move.l CD_track,d1
                cmp.b CDTOCend+3,d1
                bls Play_CD
                moveq #1,d1
                move.w d1,CD_track+2
                bra Play_CD
 
DoKey2          btst #22,d0
                beq.s DoKey3
                moveq #0,d1
                subq.b #1,CD_track+3
                move.b CD_track+3,d1
                bne Play_CD
                move.b CDTOCend+3,d1
                move.l d1,CD_track
                bra Play_CD

DoKey3          btst #20,d0
                beq.s DoKey4
                bsr GetKey
                btst #20,d0
                beq.s DoKey51
                move.l Volume,d0
                add.w #$100,d0
                bmi.s DoKey99
                move.l d0,Volume
                rts

DoKey4          btst #21,d0
                beq.s DoKey99
                bsr GetKey
                btst #21,d0
                beq.s DoKey61
                move.l Volume,d0
                sub.w #$100,d0
                bmi.s DoKey99
                move.l d0,Volume
                rts

DoKey51         move.l Panning,d0
                addq.b #8,d0
                beq.s DoKey99
                move.l d0,Panning
                rts

DoKey61         move.l Panning,d0
                beq.s DoKey99
                subq.b #8,d0
                move.l d0,Panning
                rts
Stop:           bsr Stop_CD
                st CD_stopped(a6)


DoKey99         rts

*****************
CD_ack rts
 move.l    $dfff00,d1
            and.w     #$2000,d1
            beq.b     CD_ack
            move.w    $dfff0a,d1
            move.w    d1,-(a7)
            tst.l     $dfff04
            andi.w    #$ff00,d1
            cmpi.w    #$400,d1
            bne.b     l3572
            move.w    #0,$3e00.w
            bra.b     l357a
l3572:      move.w    #1,$3e00.w
l357a:      move.w    (a7)+,d1
            rts
*****************
* CD-subs       *
****************************************
*    Setup CD Module for Mode 4, Audio *
CDmode_4:                       ; init for audio (mode 2)
        move.l  #$0,BUTCH               ; Butch enable 
;>        move.l #$00100000,BUTCH
;>        move.l  #$10000,DSCNTRL         ; turn on DSA Bus
;>        move.l  #$7,I2CNTRL             ; 5 = code, f = audio 
            move.l    #$180000,$dfff00
            move.l    #$10000,$dfff04
            move.l    #15,$dfff10
;>            move.l    #1,$dfff10


                                  ; external clk, interrupt on every sample pair
        move.l  #$14,$f1a154      ; write to Jerry
      
                                ; interpolate audio data errors
        move.w  #$1501,DS_DATA  ; DSA command
        bsr     DSA_rx
                                ; output audio data at 2X oversampled
        move.w  #$7002,DS_DATA  ; DSA command
        bsr     DSA_rx
        rts
****************************************
*  i2s data copy to Jerry on/off       *
Jeridata:                       ; d1 must have a 1 or a 0 in it 
test_d1:                        ; see if we're turning copy on or off
        cmp.l   #1,d1
        beq     Jcopy_on        ; d1 has 1, turn on copy

Jcopyoff:
        move.l  #$0,BUTCH       ; Butch enable 
        move.l  I2CNTRL,d0      ; get contents of i2s control reg
        bclr    #0,d0           ; clear bit 0
        bclr    #1,d0           ; clear bit 1
        move.l  d0,I2CNTRL      ; now do it
        bra     Jcopyxit

Jcopy_on:
        move.l  #$0,BUTCH       ; Butch enable 
        move.l  I2CNTRL,d0      ; get contents of i2s control reg
        or.l    #3,d0           ; or in the Jerry copy-on bits  
        move.l  d0,I2CNTRL      ; do it

Jcopyxit:
        rts                     ; done with i2s copy to Jerry switch
*****************************************
*  Use service mode to debug drive      *
Service:                        ; some code to test service modes
        move.w  #$F001,DS_DATA  ; kick into service mode
        bsr     DSA_rx
        move.w  #$F301,DS_DATA  ; turn on laser, try to focus it, run motor
        bsr     DSA_rx
;       move.w  #$F000,DS_DATA  ; turn off service mode
        rts
****************************************
*     Command CD to spin-up            *
****************************************
Spin_CD:                        ; spin-up command
        cmp.l   #0,d1           ; check for user-selection of mode
        bne     sessions        ; not 0, jump to multi-session mode

single:                         ; start-up normal disc
        move.w  #$1800,DS_DATA  ; Spins up on first TOC
        bsr     DSA_rx
        bsr     CD_ack
        rts                     ; end of spin-up-normal command

sessions:                       ; start-up multi-session on specified session
        or.w    #$1800,d1       ; session number must be in d1
        move.w  d1,DS_DATA
        bsr     DSA_rx
        rts                     ; end of spin-up-multi-session command
****************************************
*  Command CD to play in 1 of 3 forms  *
****************************************
                                ; 3-way switch for Play, Play @, & Play A-B
Play_CD:                        ; call play command with track number in d1
        cmp.l   #0,d1           ; see if user has cleared d1
        bne     playtrak        ; not 0, ie. has track number, so go play it

maybe_AB:
        cmp.l   #0,d3           ; if d3 has target value, user wants A-B play
        bne     A_B_play        ; branch to A-B play mode

gotimeCD:                       ; d3 was 0 so play from user's time-code setup
        move.l  d2,d4           ; safe copy of whole start time in d4
        and.l   #$00FF0000,d2   ; mask for minutes
        ror.l   #8,d2           ; shift the byte over
        ror.l   #8,d2           
        or.w    #$1000,d2       ; format it for goto
        move.w  d2,DS_DATA      ; DSA tx
        bsr     DSA_tx          ; wait till sent before sending next 1

        move.l  d4,d2           ; bring in copy of original user value of d2
        and.l   #$0000FF00,d2   ; mask for seconds
        ror.l   #8,d2
        or.w    #$1100,d2       ; format it for goto
        move.w  d2,DS_DATA      ; DSA tx
        bsr     DSA_tx          ; wait till sent before sending next 1

        move.l  d4,d2           ; bring in copy of original user value of d2
        and.l   #$000000FF,d2   ; mask for frames
        or.w    #$1200,d2       ; format it for goto
        move.w  d2,DS_DATA      ; DSA tx
        bsr     DSA_rx          ; verify receipt 
        rts                     ; end of goto time and play command

playtrak:                       ; play a track 
        or.w    #$0100,d1       ; no pause, format for DSA play-track command
        move.w  d1,DS_DATA      ; DSA TX command to play track specified
        bsr     DSA_rx          ; get response
        rts                     ; end of play-track

A_B_play:
        move.l  d2,d4           ; safe copy of whole start time in d4
        and.l   #$00FF0000,d2   ; mask for minutes
        ror.l   #8,d2           ; shift the byte over
        ror.l   #8,d2           
        or.w    #$2000,d2       ; format it for play A-B
        move.w  d2,DS_DATA      ; DSA tx
        bsr     DSA_tx          ; wait till sent before sending next 1

        move.l  d4,d2           ; bring in copy of original user value of d2
        and.l   #$0000FF00,d2   ; mask for seconds
        ror.l   #8,d2
        or.w    #$2100,d2       ; format it for play A-B
        move.w  d2,DS_DATA      ; DSA tx
        bsr     DSA_tx          ; wait till sent before sending next 1

        move.l  d4,d2           ; bring in copy of original user value of d2
        and.l   #$000000FF,d2   ; mask for frames
        or.l    #$2200,d2       ; format it for play A-B
        move.w  d2,DS_DATA      ; DSA tx
        bsr     DSA_tx          ; wait till sent before sending next 1

        move.l  d3,d4           ; safe copy of whole stop time in d4
        and.l   #$00FF0000,d3   ; mask for minutes
        ror.l   #8,d3           ; shift the byte over
        ror.l   #8,d3           
        or.w    #$2300,d3       ; format it for play A-B
        move.w  d3,DS_DATA      ; DSA tx
        bsr     DSA_tx          ; wait till sent before sending next 1

        move.l  d4,d3           ; bring in copy of original user value of d3
        and.l   #$0000FF00,d3   ; mask for seconds
        ror.l   #8,d3
        or.w    #$2400,d3       ; format it for play A-B
        move.w  d3,DS_DATA      ; DSA tx
        bsr     DSA_tx          ; wait till sent before sending next 1

        move.l  d4,d3           ; bring in copy of original user value of d3
        and.l   #$000000FF,d3   ; mask for frames
        or.l    #$2500,d3       ; format it for play A-B
        move.w  d3,DS_DATA      ; DSA tx
        bsr     DSA_rx          ; verify receipt 
        rts                     ; end of Play A_B command

****************************************
*     Command CD to stop               *
Stop_CD:                        
        move.w  #$0200,DS_DATA  ; DSA TX command to stop
        bsr     DSA_rx
        rts                     ; end of stop command

****************************************
*     Command CD to mute the decoder   *
Mute_CD:                        
        move.w  #$5100,DS_DATA  ; DSA TX command to mute
        bsr     DSA_rx
        rts                     ; end of mute command 
****************************************
*  Command CD to un-mute the decoder   *
UnmuteCD:                        
        move.w  #$51FF,DS_DATA  ; DSA TX command to un-mute
        bsr     DSA_rx
        rts                     ; end of un-mute command
****************************************
*     Command CD to pause              *
Pause_CD:                       
        move.w  #$0400,DS_DATA  ; DSA TX command to pause
        bsr     DSA_rx
        rts                     ; end of pause command
****************************************
*     Command CD to un-pause           *
Unpause_CD: 
        move.w  #$0500,DS_DATA  ; DSA TX command to un-pause
        bsr     DSA_rx
        rts                     ; end of un-pause command
****************************************
*   Command CD to send ABS timecode    *
Get_time:                       ; send-absolute-timecode command
        move.w  #$0D00,DS_DATA  
        bsr     DSA_rx          ; receive 3 times to get min:sec:frm
        bsr     DSA_rx
        bsr     DSA_rx
        rts                     ; end of get-time command
****************************************
* Command CD to send no. of sessions   *
Seshn_CD:                       ; send the number of sessions on disc 
        move.w  #$5400,DS_DATA  
        bsr     DSA_rx          
        rts                     ; end of get-sessions command
****************************************
*    Command CD to kill its A-B flags  *
KillCDAB:                       
        move.w  #$2600,DS_DATA  
        bsr     DSA_rx          
        rts                     ; end of kill A-B flags command
****************************************
*     Command CD to search forward     *
ForwrdCD:                       ; low byte of d4 sets search mode
        or.l    #$0600,d4       ; gets user's search mode byte
        move.w  d4,DS_DATA      ; DSA TX command to search
        bsr     DSA_rx
        rts                     ; end of search command
****************************************
*     Command CD to search backward    *
BckwrdCD:                       ; low byte of d4 sets search mode
        or.l    #$0700,d4       ; gets user's search mode byte
        move.w  d4,DS_DATA      ; DSA TX command to search
        bsr     DSA_rx
        rts                     ; end of search command
****************************************
*     Command CD to stop searching     *
NosrchCD:                       
        move.w  #$0800,DS_DATA  ; DSA TX command to stop searching
        bsr     DSA_rx
        rts                     ; end of stop-search command
****************************************
*     Command CD to send TOC min-max   *
CDminmax:                       ; returns first, last cut nums & endtime
        or.l    #$0300,d4       ; get user's session number
        move.w  d4,DS_DATA      
        bsr     DSA_rx          ; gets min cut number
        bsr     DSA_rx          ; gets max cut number
        bsr     DSA_rx          ; gets end min
        bsr     DSA_rx          ; gets end sec
        bsr     DSA_rx          ; gets end frame
        rts                     ; end of CDminmax command
****************************************
*     Command CD to send whole TOC     *
CDbigTOC:                       ; gets the entire table of contents
        move.l  #CD_TOC,a0      ; setup address of start of TOC storage area
        or.l    #$1400,d4       ; get user's session number
        move.w  d4,DS_DATA      ; note that CDminmax must be called first

Get_item:                       ; receive a TOC entry
        bsr     DSA_rx          ; gets cut number
        move.l  CD_wrd0,d1      ; the word just fetched from DSA Bus
        and.l   #$FF,d1         ; mask for low byte
        move.l  CDTOCend,d2     ; get highest cut number known to be on CD
        and.l   #$FF,d2         ; mask for low byte
        cmp.l   d1,d2           ; compare 'em
        beq     Enuf_TOC        ; we're done when they are equal
        bsr     DSA_rx          ; gets control and address byte
        bsr     DSA_rx          ; gets start min of cut
        bsr     DSA_rx          ; gets start sec
        bsr     DSA_rx          ; gets start frame

Saveitem:                       ; Save another valid TOC entry to memory
        move.l  CDcutnum,(a0)+
        move.l  CDcutCAB,(a0)+
        move.l  CDcutstm,(a0)+
        move.l  CDcutsts,(a0)+
        move.l  CDcutstf,(a0)+
        bra     Get_item        ; go get the next TOC entry

Enuf_TOC:                       ; get last item, and exit
        move.l  CDcutnum,(a0)+
        move.l  CDcutCAB,(a0)+
        move.l  CDcutstm,(a0)+
        move.l  CDcutsts,(a0)+
        move.l  CDcutstf,(a0)+
        move.l #$E0F,(a0)+
        rts                     ; end of CDbigTOC command
****************************************
*  Command CD to send status of disc   *
Stat_CD:                       
        move.w  #$5000,DS_DATA  
        bsr     DSA_rx
        rts                     ; end of send-disc-status command
****************************************
*     Command CD to send cut length    *
CtlnthCD:                       ; low byte of d4 must have cut $number
        or.l    #$0900,d4       ; gets user's cut number byte
        move.w  d4,DS_DATA      ; DSA TX command to search
        bsr     DSA_rx          ; do rx twice to get low byte, high byte
        bsr     DSA_rx          ; the value of the word is $seconds
        rts                     ; end of get-cut-length command
****************************************
*         DSA error handler            *
GetCDerr:                       ; gets & classifies most recent error 
        move.w  #$1600,DS_DATA  ; request error code
        bsr     DSA_rx          ; receive it
        move.l  CD_error,d1     ; analyze it
        and.l   #$FF,d1         ; low byte only, please
        cmp.l   #0,d1           ; if it's 0 there's no error...
        beq     Clearerr        ; so blow out of here, otherwise...
        cmp.l   #$1F,d1         ; see if its fatal or not
        bge     Retry_OK        ; not fatal

Fatals:
        move.l  CDfatals,d0     ; get current number of fatal errors
        add.l   #1,d0           ; increment
        move.l  d0,CDfatals     ; store it
        bra     Clearerr        ; done
        
Retry_OK:
        move.l  CDmaybes,d0     ; get current number of retry-able errors
        add.l   #1,d0           ; increment
        move.l  d0,CDmaybes     ; store it

Clearerr:
        move.w  #$1700,DS_DATA  ; ask CD to clear error its register
        bsr     DSA_rx
        rts                     ; end of DSA error handler
****************************************
*   Transmit a DSA Bus command         *
;                               ****************************************
DSA_tx:                         ; set up as a polling loop
        move.l  BUTCH,d1        ; get Butch's ICR into d1
        and.l   #$1000,d1       ; mask for d12, DSA TX Intr. pending
        beq     DSA_tx          ; nothing here yet, so wait for bit to set 
        move.w  DS_DATA,d1      ; flag set, so get the word from Butch
        move.l  d1,CD_wrd0      ; store it where Sort can find it
        move.l  DSCNTRL,d5      ; read here to clear interrupt flag
        bra     Sort_CD         ; parse the DSA response
****************************************
* Receive DSA Bus response & parse it  *
DSA_rx:                         ; set up as a polling loop
        move.l  BUTCH,d1        ; get Butch's ICR into d1
        and.l   #$2000,d1       ; mask for d13, DSA RX Intr. pending
        beq     DSA_rx          ; nothing here yet, so wait for bit to set 
        move.w  DS_DATA,d1      ; flag set, so get the word from Butch
        move.l  d1,CD_wrd0      ; store it where we can see it for debugging
        move.l  DSCNTRL,d5      ; read here to clear interrupt flag
;       bra     Endsort         ; un-comment to skip the sorting business
****************************************
* Sort the received data               *
Sort_CD:                        ; the commands are decoded per DSA spec.
        move.l  CD_wrd0,d1      ; load data word 
        move.l  d1,d2           ; copy it for debugging
        andi.l  #$FF00,d1       ; mask to see hi byte only

cmnd_01:                        ; parse it
        cmp.l   #$0100,d1       ; test
        beq     Found           ; found "found" message

cmnd_03:                        ; parse it
        cmp.l   #$0300,d1       ; test
        beq     Discstat        ; found disc status message

cmnd_04:                        ; parse it
        cmp.l   #$0400,d1       ; test
        beq     error           ; found error message

cmnd_09:                        ; parse it
        cmp.l   #$0900,d1       ; test
        beq     CutlenL         ; found cut-length low byte of seconds 

cmnd_0A:                        ; parse it
        cmp.l   #$0A00,d1       ; test
        beq     CutlenH         ; found cut-length high byte of seconds 

cmnd_10:                        ; parse it
        cmp.l   #$1000,d1       ; test
        beq     track           ; found track number

cmnd_11:
        cmp.l   #$1100,d1       ; test
        beq     index           ; found index

cmnd_12:
        cmp.l   #$1200,d1       ; test
        beq     rel_mins        ; found rel. minutes

cmnd_13:
        cmp.l   #$1300,d1       ; test
        beq     rel_secs        ; found rel. seconds

cmnd_14:
        cmp.l   #$1400,d1       ; test
        beq     abs_mins        ; found abs. minutes 

cmnd_15:
        cmp.l   #$1500,d1       ; test
        beq     abs_secs        ; found abs. seconds 

cmnd_16:
        cmp.l   #$1600,d1       ; test
        beq     frames          ; found frames

cmnd_17:
        cmp.l   #$1700,d1       ; test
        beq     Mode            ; found mode

cmnd_20:
        cmp.l   #$2000,d1       ; test
        beq     firs_trk        ; found first track number in TOC

cmnd_21:
        cmp.l   #$2100,d1       ; test
        beq     endtrack        ; found last track number in TOC

cmnd_22:
        cmp.l   #$2200,d1       ; test
        beq     end_mins        ; found last minute of last track in this TOC
      
cmnd_23:
        cmp.l   #$2300,d1       ; test
        beq     end_secs        ; found last second of last track in this TOC

cmnd_24:
        cmp.l   #$2400,d1       ; test
        beq     endframe        ; found last frame of last track in this TOC

cmnd_54:
        cmp.l   #$5400,d1       ; test
        beq     Sessions        ; found Number of Sessions on disc message

cmnd_60:
        cmp.l   #$6000,d1       ; test
        beq     Cutnum          ; found TOC cut number

cmnd_61:
        cmp.l   #$6100,d1       ; test
        beq     CutCAB          ; found TOC cut control and address byte

cmnd_62:
        cmp.l   #$6200,d1       ; test
        beq     Cutstm          ; found TOC cut start minute

cmnd_63:
        cmp.l   #$6300,d1       ; test
        beq     Cutsts          ; found TOC cut start sec

cmnd_64:
        cmp.l   #$6400,d1       ; test
        beq     Cutstf          ; found TOC cut start frame

cmnd_70:
        cmp.l   #$7000,d1       ; test
        beq     DAC             ; found DAC setting
        bra     Endsort         ; no command number match - fell thru to here

DAC:                            ; now copy the value to named storage 
        move.l  d2,CD_DAC
        bra     Endsort

Discstat:
        move.l  d2,CD_stat
        bra     Endsort

Mode:
        move.l  d2,_CD_setup
        bra     Endsort

Found:
        move.l  d2,CD_found
        bra     Endsort

error:
        move.l  d2,CD_error
        bra     Endsort

track:                          
        move.l  d2,CD_track     
        bra     Endsort         

index:
        move.l  d2,CD_index     
        bra     Endsort

abs_mins:
        move.l  d2,CD_Amins      
        bra     Endsort

abs_secs:
        move.l  d2,CD_Asecs
        bra     Endsort

rel_mins:                       
        move.l  d2,CD_Rmins     
        bra     Endsort

rel_secs:                       
        move.l  d2,CD_Rsecs
        bra     Endsort

frames:
        move.l  d2,CD_Afrms
        bra     Endsort

firs_trk:
        move.l  d2,CDTOCbeg
        bra     Endsort

endtrack:
        move.l  d2,CDTOCend
        bra     Endsort

end_mins:
        move.l  d2,CDTOCmin
        bra     Endsort

end_secs:
        move.l  d2,CDTOCsec
        bra     Endsort

endframe:
        move.l  d2,CDTOCfrm
        bra     Endsort

Sessions:
        move.l  d2,CDseshns
        bra     Endsort

CutlenL:
        move.l  d2,CDcutlnL
        bra     Endsort

CutlenH:
        move.l  d2,CDcutlnH
        bra     Endsort

Cutnum:
        move.l  d2,CDcutnum
        bra     Endsort

CutCAB:
        move.l  d2,CDcutCAB
        bra     Endsort

Cutstm:
        move.l  d2,CDcutstm
        bra     Endsort

Cutsts:
        move.l  d2,CDcutsts
        bra     Endsort

Cutstf:
        move.l  d2,CDcutstf
      
Endsort:
        rts                     ; end of sorting routine
****************************************
 
***************** 
InitCDBIOS::   lea CDBIOS(pc),a0
                lea $3000.w,a1
                move.w #(CDBIOSEND-CDBIOS)>>2,d0
xferlp1         move.l (a0)+,(a1)+
                dbra d0,xferlp1
                rts

                even
CDBIOS          inline "e:\cdbios45.bin"
CDBIOSEND:

*****************
*    DSP-Prg    *
DSP_PRG:        inline "cd_audio\cdplay.o"
        
InitDSP:        lea  DSP_PRG+4(pc),a0
                move.l  (a0)+,d0        ; Final location of DSP code 
                move.l  d0,a1
                move.l  (a0)+,d1        ; Size in bytes
                asr.l   #2,d1
InitDSP1:       move.l  (a0)+,(a1)+
                dbra    d0,InitDSP1

                move.l  d0,D_PC         ; Set DSP PC to start of code in SRAM
                moveq #1,d0
                move.l  d0,D_CTRL       ; set DSP GO bit to start running
                rts
*****************

****************
* ReadJoyPad1  *
* left joypad  *

JoyA_1          EQU $810E
JoyA_2          EQU $810D
JoyA_3          EQU $810B
JoyA_4          EQU $8107

ReadJoyPad1:    movem.l d0-d2,-(sp)
                move.l  #$F0FFFFFC,d1
                moveq   #$FF,d2
                lea     $F14000,a0
                move.w  #JoyA_1,(a0)
                move.l  (a0),d0
                or.l    d1,d0
                ror.l   #4,d0
                and.l   d0,d2   ; A,Pause,Cursor

                move.w  #JoyA_2,(a0)
                move.l  (a0),d0
                or.l    d1,d0
                ror.l   #8,d0
                and.l   d0,d2   ; B,1,4,7,*

                move.w  #JoyA_3,(a0)
                move.l  (a0),d0
                or.l    d1,d0
                rol.l   #6,d0
                rol.l   #6,d0
                and.l   d0,d2   ; C,2,5,8,0

                move.w  #JoyA_4,(a0)
                move.l  (a0),d0
                or.l    d1,d0
                rol.l   #8,d0
                and.l   d0,d2   ; Option,3,6,9,#

                not.l   d2
                move.l d2,KeyCurrent(a6)
                movem.l (sp)+,d0-d2
                rts
****************
* Keyboard     *
                LOCAL
Keyboard        movem.l d0-d2/a0,-(sp)

                bsr ReadJoyPad1
                move.l KeyCurrent(a6),d0
                move.l d0,d1
                beq.s .l100

                move.l KeyMask(a6),d2
                and.l d2,d0
                not.l d2
                and.l d2,d1
                beq.s .l3                       ; nor repeatable key

                cmp.l KeyLastRep(a6),d1         ; same as before
                beq.s .l1
                  move.l d1,KeyLastRep(a6)      ; and save current key
                  move.w #50,KeyCounter(a6)     ; delay
                  bra.s .l3

.l1             subq.w #1,KeyCounter(a6)        ; delay finished ?
                bpl.s .l2                       ; no =>
                clr.w KeyCounter(a6)          ; but first delay again
                bra .l3                       ; =0 => was repeat
.l2             moveq #0,d1                     ; we're still in delay

.l3             tst.l d0
                beq.s .l4                       ; =0 => there're non
                cmp.l KeyLast(a6),d0            ; same as last time
                bne.s .l4
                moveq #0,d0
                bra.s .l5

.l4             move.l d0,KeyLast(a6)
.l5             or.l d1,d0                      ; merge
                beq.s .l99                      ; zero => no key

                lea KeyBuffer(a6),a0
                move.w KeyPtrIn(a6),d1
                move.l d0,(a0,d1.w)             ; insert in buffer
                addq.w #4,d1                    ; increase ptr
                and.w #7*4,d1                   ; wrap ptr
                move.w d1,KeyPtrIn(a6)
                cmp.w KeyPtrOut(a6),d1          ; overrun ?
                bne.s .l99
                  addq.w #4,d1                  ; yes => increas out-ptr
                  and.w #7*4,d1
                  move.w d1,KeyPtrOut(a6)
.l99:           movem.l (sp)+,d0-d2/a0
                rts

.l100           clr.l KeyLast(a6)               ; realy no key =>
                clr.l KeyLastRep(a6)            ; clear last ones
                movem.l (sp)+,d0-d2/a0
                rts
****************
* GetKey       *
                LOCAL
GetKey:         move.w KeyPtrOut(a6),d0
                cmp.w KeyPtrIn(a6),d0
                beq.s .l99
                movem.l d1/a0,-(sp)
                move.w d0,d1
                lea KeyBuffer(a6),a0
                move.l 0(a0,d1.w),d0
                addq.w #4,d1
                and.w #7*4,d1
                move.w d1,KeyPtrOut(a6)
                movem.l (sp)+,d1/a0
                tst.l d0
                rts

.l99            moveq #0,d0
                rts
****************

DoTimer::       bsr Keyboard
                rts

*********************************************
* Init- und Hilfsroutine fr den Bildschirm *
* (c) 1994 Bastian Schick                   *
*****************
* screen        *
*****************
* Objekt-Defs   *
NEXT_OBJ         EQU 1
***************************************
* BitMap oder Scaled BitMap - Objekte *
***************************************
                RSRESET
                RS.w obj_bm_type                ; Type
                RS.w obj_bm_l                   ; Gre des Objektes (fr MakeOBL)
                RS.l obj_bm_data                ; Data
                RS.w obj_bm_x                   ; X
                RS.w obj_bm_y                   ; Y pos in Halbzeilen
                RS.w obj_bm_height              ; Hhe ODER cc bei BRANCH OBJECT
                RS.w obj_bm_link                ; Abstand zum Nchsten Objekt in Objekten
                RS.b obj_bm_bits                ; Bits pro Pixel
                RS.b obj_bm_pitch               ; Pitch
                RS.w obj_bm_dwidth              ; Breite in Phrases
                RS.w obj_bm_iwidth              ; Bildbreite (sichtbar)
                RS.b obj_bm_cindex              ; Farb-Offset
                RS.b obj_bm_flags               ; Flags
                RS.w obj_bm_firstpx             ; FirstPixel
obj_bm_len      EQU RSCOUNT
                RS.b obj_dummy1
                RS.b obj_sc_rem
                RS.b obj_sc_vscale
                RS.b obj_sc_hscale              ; Ergnzungen fr Scaled BitMap
obj_sc_len      EQU RSCOUNT

**************
* GPU-Object *
**************
                RSRESET
                RS.w obj_gp_type
                RS.w obj_gp_l                   ; Gre des Objektes (fr MakeOBL)
                RS.l obj_gp_data1
                RS.l obj_gp_data2
                RS.w obj_gp_link

obj_gp_len      EQU RSCOUNT
*****************
* Branch-Object *
*****************
                RSRESET
                RS.w obj_br_type
                RS.w obj_br_l                   ; Gre des Objektes (fr MakeOBL)
                RS.w obj_br_y
                RS.w obj_br_cc                  ; Bedingung
                RS.w obj_br_link,2
obj_br_len      EQU RSCOUNT

BRA_OBJ         MACRO ; y_pos,cc,dest
                dc.w 3,obj_br_len
                dc.w \1         ; y
                IFNE "\2"="<"
                dc.w 1
                ELSE
                IFNE "\2"=">"
                dc.w 2
                ELSE
                IFNE "\2"="="
                dc.w 0
                ENDIF
                ENDIF
                ENDIF
                dc.w \3,NEXT_OBJ
                ENDM

***************
* Stop-Object *
***************
                RSRESET
                RS.w obj_st_type
                RS.w obj_st_l
                RS.w obj_st_int
                RS.l obj_st_data1
                RS.l obj_st_data2
obj_st_len      EQU RSCOUNT
*****************
*    MakeOBL    *
MakeOBL:          movem.l d0-a4,-(sp)

                  move.l  #$FF000000,d4

                  lea     ob_list0(a6),a0       ; original
                  lea     ob_list(a6),a1        ; Zieladresse
                  lea     (a1),a4          ; start merken
                  moveq   #0,d7            ; object counter

                  lea     Objekte(pc),a2    ; source

loop_mo:          lea     (a2),a3          ; Ptr auf akt. Objekt retten
                  movem.w (a2)+,d1/d5      ; Type
                  tst.w   d1
                  bpl.s   ok_mo
                  cmp.w   #$AFFE,d1
                  beq     exit_mo
                  lea     -4(a2,d5.w),a2
                  bra.s   loop_mo

ok_mo:            addq.w  #1,d7
                  and.w   #7,d1
                  ext.l   d1
                  move.w  d1,d0
                  subq.w  #2,d0
                  bmi     bm_sc_mo
                  beq     gpu_mo           ; 2=GPU-Object
                  subq.w  #2,d0
                  bmi.s   branch_mo        ; 3=Branch Object
* Stop-Objekt erzeugen
                  moveq   #1,d0
                  and.w   (a2)+,d0
                  lsl.w   #3,d0
                  or.w    d0,d1            ; Interrupt Flag
                  movem.l (a2)+,d0/d2

                  lsl.l   #4,d2
                  or.l    d2,d1
                  move.l  d0,(a0)+
                  move.l  d1,(a0)+
                  lea     24(a0),a0
                  lea     32(a1),a1
                  bra.s   loop_mo
* branch_object
branch_mo:        move.w  #$07FF,d0
                  and.w   (a2)+,d0
                  lsl.w   #3,d0
                  or.w    d0,d1            ; Ypos
                  moveq   #7,d0
                  and.w   (a2)+,d0
                  swap    d0
                  lsr.l   #2,d0
                  or.l    d0,d1            ; CC

                  move.l  a1,d3            ; akt. Pos merken
                  move.w  (a2)+,d0         ; nchstes Objekt falls CC true
                  bpl.s   ok_bra_mo
                  neg.w   d0
                  move.l  a4,d3            ; sonst absolute
ok_bra_mo:        asl.w   #5,d0            ; * 32
                  ext.l   d0
                  add.l   d3,d0
                  lsr.l   #3,d0
                  ror.l   #8,d0
                  move.l  d0,d3
                  and.l   d4,d0
                  or.l    d0,d1            ; Link (24..31)
                  move.l  d3,d0
                  and.l   #$00FFFFFF,d0
                  move.l  d0,(a0)+
                  move.l  d1,(a0)+

                  move.w  #($07FF<<3)|3,d1 ; Branch Always
                  ext.l   d1
                  move.w  (a2)+,d0         ; nchstes Objekt
                  asl.w   #5,d0            ; * 32
                  ext.l   d0
                  add.l   a1,d0
                  lsr.l   #3,d0
                  ror.l   #8,d0
                  move.l  d0,d3
                  and.l   d4,d0
                  or.l    d0,d1            ; Link (24..31)
                  move.l  d3,d0
                  and.l   #$00FFFFFF,d0
                  move.l  d0,(a0)+
                  move.l  d1,(a0)+
                  lea     16(a0),a0
                  lea     32(a1),a1
                  bra     loop_mo
* GPU Object
gpu_mo:           movem.l (a2)+,d0/d1
                  and.w #$fff8,d1
                  addq #2,d1
                  swap    d2
                  move.l  d0,(a0)+
                  move.l  d1,(a0)+

                  move.w  #($07FF<<3)|3,d1 ; Branch Always
                  ext.l   d1
                  move.w  (a2)+,d0         ; nchstes Objekt
                  lsl.w   #5,d0            ; * 32
                  ext.l   d0
                  add.l   a1,d0
                  lsr.l   #3,d0
                  ror.l   #8,d0
                  move.l  d0,d3
                  and.l   d4,d0
                  or.l    d0,d1            ; Link (24..31)
                  move.l  d3,d0
                  and.l   #$00FFFFFF,d0
                  move.l  d0,(a0)+
                  move.l  d1,(a0)+
                  lea     16(a0),a0
                  lea     32(a1),a1
                  bra     loop_mo

* BitMap oder Scaled BitMap
bm_sc_mo:         moveq   #$F8,d0
                  and.l   (a2)+,d0         ; Data-Adress (3..23)
                  bpl.s   ok_bm_sc_mo
                  neg.l   d0
                  add.l   a6,d0
ok_bm_sc_mo:      lsl.l   #8,d0            ; an 63..43

                  move.w  (a2)+,d6         ; X
                  and.w   #$0FFF,d6        ; im 2. Phrase 0..11
                  ext.l   d6

                  move.w  (a2)+,d3
                  and.w   #$07FF,d3
                  lsl.w   #3,d3
                  or.w    d3,d1            ; Y-Pos (3..13)

                  moveq   #0,d3
                  move.w  (a2)+,d3
                  and.w   #$03FF,d3
                  swap    d3
                  lsr.l   #2,d3
                  or.l    d3,d1            ; Hhe (14..23)

                  move.w  (a2)+,d3         ; nchstes Objekt
                  lsl.w   #5,d3            ; * 32
                  ext.l   d3
                  add.l   a1,d3
                  lsr.l   #3,d3
                  ror.l   #8,d3
                  move.l  d3,d2            ; Link retten
                  and.l   d4,d3
                  or.l    d3,d1            ; Link (24..31)

                  move.l  d2,d3
                  and.l   #$00FFFFFF,d3
                  or.l    d3,d0
                  move.l  d0,(a0)+
                  move.l  d1,(a0)+

                  moveq   #7,d0
                  and.b   (a2)+,d0
                  ror.w   #4,d0
                  or.w    d0,d6            ; Depth (12..14)

                  moveq   #7,d0
                  and.b   (a2)+,d0
                  swap    d0
                  lsr.l   #1,d0
                  or.l    d0,d6            ; Pitch (15..17)

                  moveq   #0,d0
                  move.w  (a2)+,d0
                  and.w   #$03FF,d0
                  lsl.w   #2,d0
                  swap    d0
                  or.l    d0,d6            ; Dwidth (18..27)

                  moveq   #0,d0
                  move.w  (a2)+,d0
                  and.w   #$03FF,d0
                  ror.l   #4,d0
                  move.l  d0,d1
                  clr.w   d0
                  or.l    d0,d6            ; IWidth (28..31)
                  ext.l   d1               ; und (32..37)

                  moveq   #$7F,d0
                  and.b   (a2)+,d0
                  lsl.w   #6,d0
                  or.w    d0,d1            ; Index (38..44)

                  moveq   #$0F,d0
                  and.b   (a2)+,d0
                  swap    d0
                  lsr.l   #3,d0
                  or.l    d0,d1            ; Flags (45..48)

                  moveq   #$3F,d0
                  and.w   (a2)+,d0

                  add.w   d0,d0
                  swap    d0
                  or.l    d0,d1
                  move.l  d1,(a0)+
                  move.l  d6,(a0)+

                  lea     16(a0),a0
                  lea     32(a1),a1
                  cmp.w   #obj_sc_len,d5   ; Sized Object
                  bne     loop_mo
                  move.l  (a2)+,-12(a0)
;                  move.b  d0,-8(a0)
;                  move.b  d1,-9(a0)
;                  move.b  d2,-10(a0)
;                  clr.b   -11(a0)
                  bra     loop_mo
exit_mo:          clr.l   (a0)+
                  moveq   #4,d0
                  move.l  d0,(a0)+
                  addq.w  #1,d7
                  move.w  d7,count_obj(a6)
                  movem.l (sp)+,d0-a4
                  rts
*****************
*    CopyOBL    *
CopyOBL:          movem.l d1/a0-a1,-(sp)
 move usp,a0
 addq.l #1,a0
 move a0,usp
                  lea     ob_list(a6),a0
                  lea     ob_list0(a6),a1
                  move.w  count_obj(a6),d1
cobl:
                REPEAT
                  move.l  (a1)+,(a0)+
                UNTIL #8
                  dbra    d1,cobl
                  movem.l (sp)+,d1/a0-a1
                  rts
*****************
*   VideoInit   *

; THESE ARE THE NTSC DEFINITIONS
ntsc_width      EQU 1409
ntsc_hmid       EQU 823

ntsc_height     EQU 241
ntsc_vmid       EQU 266

; THESE ARE THE PAL DEFINITIONS
pal_width       EQU 1381
pal_hmid        EQU 843

pal_height      EQU 287
pal_vmid        EQU 322

VideoInit:        movem.l d0-d3/a0,-(sp)
                  lea     $00F00000,a0
                  move.w  #322-287,d0      ; vdb
                  move.w  #322+287,d1      ; vde
                  move.w  #(1381+28)>>1-1|$0400,d2 ; hde
                  move.w  #843-(1381+28)>>1+4,d3 ; hdb
                  btst    #4,$00F14003
                  beq.s   VideoInit1       ; =0 => PAL
                  move.w  #266-241,d0
                  move.w  #266+241,d1
                  move.w  #(1409>>1-1)|$0400,d2
                  move.w  #823-(1409>>1)+4,d3
VideoInit1:       move.w  d0,$0046(a0)
                  move.w  d1,$0048(a0)
                  move.w  d2,$003C(a0)
                  move.w  d3,$0038(a0)
                  move.w  d3,$003A(a0)
                  move.w  d0,a_vdb(a6)
                  move.w  d1,a_vde(a6)
                  movem.l (sp)+,d0-d3/a0
                  rts
*****************
*    InitOP     *
InitOP:           lea $00F00000,a0
                  moveq #$fe,d0
                  and.w  a_vde(a6),d0
                  move.w d0,$48(a0)
                  or.w #1,d0
                  move.w  d0,$4E(a0)

                  bsr     MakeOBL
                  bsr     CopyOBL

                  lea     ob_list(a6),a1
                  move.l  a1,d0
                  swap    d0
                  move.l  d0,$0020(a0)     ; OPL = $10000
                  move.l  #$1F09<<16,$00E0(a0)
                  lea     my_irq(pc),a0
                  move.l  a0,$00000100.w
                  move    #$2000,sr
                  rts
*****************
*      IRQ      *
my_irq:         movem.l d0-d1,-(sp)
                move.w $f000e0,d0
                btst    #0,d0
                beq.s   no_vi
                bsr CopyOBL
no_vi:          btst #3,d0
                beq.s no_timer
                bsr DoTimer
no_timer        lsl.w #8,d0
                or.w #%1001,d0
                swap d0
                move.l d0,$00F000E0
                movem.l (sp)+,d0-d1
                rte
*****************
*********************************************
* TextScreen (8x8 Font)                     *
* created 24.9.95
* (c) Bastian Schick
*****************
* var-base is A6
* predefined constants: max_x_txt,max_y_txt,(max_x_txt>>3)
*            variables: TextScreen.l,Cursor.l
*
* subroutines:
* PrintA0,PrintBIN16,PrintBIN,PrintDEZ,PrintDEZ2,PrintHEX,PrintHEXl,PrintDigit,PrintChar
* InitTxtScreen(d0.w = ColorIndex,d1.l = Color)
*****************

**********************
PrintA0::         movem.l d0/a0,-(sp)
loop_pa:          move.b  (a0)+,d0
                  beq.s   exit_pa
                  bsr     PrintChar
                  bra.s   loop_pa
exit_pa:          movem.l (sp)+,d0/a0
                  rts
PrintBIN16:       movem.l d0-d2,-(sp)
                  moveq   #15,d1
                  move.l  d0,d2
loop_pb16:        moveq   #0,d0
                  add.w   d2,d2
                  bcc.s   ok_pb16
                  addq.w  #1,d0
ok_pb16:          bsr     PrintDigit
                  dbra    d1,loop_pb16
                  movem.l (sp)+,d0-d2
                  rts
PrintBIN::        movem.l d0-d2,-(sp)
                  moveq   #31,d1
                  move.l  d0,d2
loop_pb:          moveq   #0,d0
                  add.l   d2,d2
                  bcc.s   ok_pb
                  addq.w  #1,d0
ok_pb:            bsr     PrintDigit
                  dbra    d1,loop_pb
                  movem.l (sp)+,d0-d2
                  rts
PrintDEZ::        move.l  d0,-(sp)
                  and.l   #$0000FFFF,d0
                  divu    #10000,d0
                  bsr     PrintDigit
                  swap    d0
                  ext.l   d0
                  divu    #1000,d0
                  bsr     PrintDigit
                  swap    d0
                  ext.l   d0
                  divu    #100,d0
                  bsr     PrintDigit
                  swap    d0
                  ext.l   d0
                  divu    #10,d0
                  bsr     PrintDigit
                  swap    d0
                  ext.l   d0
                  bsr     PrintDigit
                  move.l  (sp)+,d0
                  rts
PrintDEZ2::       and.l   #$0000FFFF,d0
                  divu    #10,d0
                  bsr.s   PrintDigit
                  swap    d0
                  ext.l   d0
                  bsr.s   PrintDigit
                  rts
PrintHEXl::       move.l  d0,-(sp)
                  swap    d0
                  bsr.s   PrintHEX
                  move.l  (sp),d0
                  bsr.s   PrintHEX
                  moveq   #" ",d0
                  bsr.s   PrintChar
                  move.l  (sp)+,d0
                  rts
PrintHEX::        move.w  d0,-(sp)
                  move.b  (sp),d0
                  bsr.s   PrintHEX1
                  move.w  (sp)+,d0
PrintHEX1:        move.w  d0,-(sp)
                  lsr.w   #4,d0
                  and.w   #$000F,d0
                  move.b  Ziffern(pc,d0.w),d0
                  bsr.s   PrintChar
                  moveq   #$0F,d0
                  and.w   (sp),d0
                  move.b  Ziffern(pc,d0.w),d0
                  bsr.s   PrintChar
                  move.w  (sp)+,d0
                  rts
Ziffern:        DC.B "0123456789ABCDEF"
InitTxtScreen::   add.w d0,d0
                  lea $f00400,a0
                  move.l d1,0(a0,d0.w)
;                  move.l  TextScreen(a6),a0
                  lea TextScreen,a0
                  move.w  #(max_x_txt>>3*max_y_txt)>>2-1,d0
                  moveq   #0,d1
.loop             move.l  d1,(a0)+
                  dbra    d0,.loop
                  move.l d1,Cursor(a6)
                  rts
PrintDigit::      add.b   #"0",d0
PrintChar::       movem.l d0/a0-a1,-(sp)
                  and.w   #$00FF,d0
                  add.w   d0,d0
                  add.w   d0,d0
                  add.w   d0,d0
                  lea     ASCII+8(pc,d0.w),a0
;                  move.l  TextScreen(a6),a1
                  lea TextScreen,A1
                  move.w  Cursor+2(a6),d0
                  mulu    #max_x_txt,d0
                  add.w   Cursor(a6),d0
                  adda.w  d0,a1
                  addq.w  #1,Cursor(a6)
                  cmpi.w  #(max_x_txt>>3),Cursor(a6)
                  bne.s   ok_pc
                  clr.w   Cursor(a6)
                  addq.w  #1,Cursor+2(a6)
                  cmpi.w  #max_y_txt>>8,Cursor+2(a6)
                  bne.s   ok_pc
                  clr.w   Cursor+2(a6)
ok_pc::           move.b  (a0)+,(a1)
                  move.b  (a0)+,(max_x_txt>>3)(a1)
                  move.b  (a0)+,2*(max_x_txt>>3)(a1)
                  move.b  (a0)+,3*(max_x_txt>>3)(a1)
                  move.b  (a0)+,4*(max_x_txt>>3)(a1)
                  move.b  (a0)+,5*(max_x_txt>>3)(a1)
                  move.b  (a0)+,6*(max_x_txt>>3)(a1)
                  move.b  (a0)+,7*(max_x_txt>>3)(a1)
                  movem.l (sp)+,d0/a0-a1
                  rts


ASCII:            INLINE 'FONT\LIGHT8x8.FNT'
* FNT-Header
* dc.l "JFNT"
* dc.b first_char,last_char
* dc.b height
* dc.b dummy  ; perhabs soon width ?)
*********************************************
Objekte:
* Stop-Objekte (sparen Bus-Zeit !!)
* 0
                BRA_OBJ 30,<,-4                 ; y<30 => Objekt 3 = STOP
                BRA_OBJ 601,>,-4                ; y>601 => STOP
* 2
* Text-Screen
                DC.W 0,obj_bm_len
                DC.L TextScreen
                DC.W (443-320)/2                ; x_start
                DC.W 60                         ; y_start
                DC.W max_y_txt                  ; Hhe
                DC.W NEXT_OBJ
                DC.B 0,1                        ; 1 Bit Farbtiefe,Pitch 1
                DC.W max_x_txt>>6,max_x_txt>>6
                DC.B 0,0
                DC.W 0
* 3
                DC.W 0,obj_bm_len
                DC.L GfxScreen
                DC.W (443-320)/2
                DC.W 60+(max_y_txt)*2+2
                DC.W max_y_gfx
                DC.W NEXT_OBJ
                DC.B 4,1                        ; 16Bit = CRY
                DC.W max_x_gfx*2/8,max_x_gfx*2/8            ; 320*16Bit/64Bit(pro Phrase)
                DC.B 0,0
                DC.W 0
*4
                DC.W $AFFE                      ; generates STOPOBJ

